package io.zipcoder;

import java.util.Stack;

public class ParenChecker {

    public boolean isMatchingpair(char char1, char char2) {

        if(char1 == '(' && char2 == ')' || char1 == '{' && char2 == '}' || char1 == '[' && char2 == ']' ||char1 == '<' && char2 == '>')
        {return true;}
        else
        {return false;}
    }

    public boolean balPare(String brackets, char open, char close) {

        Stack st = new Stack();

        for(int i=0; i<brackets.length(); i++){

            if(brackets.charAt(i) == open){
                st.push(brackets.charAt(i));
            }

            if(brackets.charAt(i)== close){
                if (st.isEmpty()){
                    return false;
                } else if (!isMatchingpair((Character) st.pop(), brackets.charAt(i))){
                    return false;
                }
            }
        }
        if (st.isEmpty()){
            return true;
        } else {
            return false;
        }
    }

    public boolean balancedCharacters(String brackets) {

        int singleCount = 0;
        int doubleCount = 0;

        for (int i = 0; i < brackets.length(); i++) {
            if (brackets.charAt(i) == '\'') { singleCount++;}
            else if(brackets.charAt(i) == '"'){doubleCount++;}
        }

        boolean parenth = balPare(brackets, '(', ')');
        boolean square = balPare(brackets, '[', ']');
        boolean curly = balPare(brackets, '{', '}');
        boolean angle = balPare(brackets, '<', '>');

        if (parenth &&  square && curly && angle && singleCount%2 == 0 && doubleCount%2 == 0) {
            return true;
        } else {return false;}

    }


}
